<?php
namespace Planejamento\Repositories;

class Autoforne extends \Doctrine\ORM\EntityRepository
{
    public function getAutoForne($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
         SELECT MAX(T.CDTPCTPAGAR) AS CDTPCTPAGAR,
                   MAX(T.CDCLASSFINA) AS CDCLASSFINA
            FROM TIPOCTPAGAR T, AUTOFORNE A, NFRELACAF N
            WHERE N.CDFILIAL    = :P_CDFILIAL   AND
                  N.NRLANCTONF  = :P_NRLANCTONF AND
                  N.NRORG       = :P_NRORG      AND
                  A.CDFILDEST   = N.CDFILDEST   AND
                  A.CDFILLANC   = N.CDFILLANC   AND
                  A.NRAUTOFORN  = N.NRAUTOFORN  AND
                  A.NRORG       = N.NRORG       AND
                  A.CDTPCTPAGAR = T.CDTPCTPAGAR AND
                  A.NRORG       = T.NRORG
SQL;

        $params = array(
            "P_NRLANCTONF" => $nrlanctonf,
            "P_CDFILIAL" => $cdfilial,
            "P_NRORG" => $nrorg
        );

        try {
            return $this->getEntityManager()->getConnection()->fetchAssoc($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }


}

//
// ###################################################################################
// ############ DEVE SER REMOVIDO APOS FINALIZACAO DO ESBOCO #########################
// ###################################################################################

use \Geral\Entities\Paramfilial;
use \Geral\Util\Ambiente;
use \Geral\Util\DateUtil;


class Facade
{

    public static function retornaSqlAFsParaImportacao()
    {
        $cdfilial   = Ambiente::getCdFilial();
        $nrorg      = Ambiente::getNrorg();
        $cdforneced = tk_get_field_value("CDFORNECED");
        $dtinicial  = tk_get_field_value("DTINICIAL");
        $dtfinal    = tk_get_field_value("DTFINAL");
        $dtTodas    = ($dtinicial && $dtfinal) ? "" : "T";
        $dtprocini  = "";
        $dtminvazia = "";
        $dtprocfin  = "";
        $dtmaxvazia = "";

        $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($cdfilial, $nrorg);
        if ($paramfilial->getNrmaxdiaantdtaf()) {
            $dtprocini  = DateUtil::getDataAtual();
            $dtprocini  = DateUtil::subtraiIntervalo($dtprocini, $paramfilial->getNrmaxdiaantdtaf());
            $dtminvazia = "";
        } else {
            // @todo verificar: primeiro dia do contador de datas = dtinicial?
            $dtprocini  = $dtinicial;
            $dtminvazia = "T";
        }

        if ($paramfilial->getNrmaxdiaposdtaf()) {
            $dtprocfin  = DateUtil::getDataAtual();
            $dtprocfin  = DateUtil::adicionaIntervalo($dtprocfin, $paramfilial->getNrmaxdiaposdtaf());
            $dtmaxvazia = "";
        } else {
            // @todo verificar: primeiro dia do contador de datas = dtinicial?
            $dtprocfin  = $dtinicial;
            $dtmaxvazia = "T";
        }
    }

}